Initial public busybox upstream commit
[busybox4maemo] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     "$@" >>$EXE.out 2>&1
45     exitcode=$?
46     return $exitcode
47 }
48
49 check_cc() {
50     local tempname="/tmp/temp.$$.$RANDOM"
51     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
52     # "-xc": C language. "/dev/null" is an empty source file.
53     if $CC $1 -shared -xc /dev/null -o "$tempname".o >/dev/null 2>&1; then
54         echo "$1";
55     else
56         echo "$2";
57     fi
58     rm "$tempname".o 2>/dev/null
59 }
60
61 check_libc_is_glibc() {
62     local tempname="/tmp/temp.$$.$RANDOM"
63     echo "\
64         #include <stdlib.h>
65         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
66         #if defined(__GLIBC__) && !defined(__UCLIBC__)
67         syntax error here
68         #endif
69         " >"$tempname".c
70     if $CC "$tempname".c -c -o "$tempname".o >/dev/null 2>&1; then
71         echo "$2";
72     else
73         echo "$1";
74     fi
75     rm "$tempname".c "$tempname".o 2>/dev/null
76 }
77
78 EXE="$1"
79 CC="$2"
80 CFLAGS="$3"
81 LDFLAGS="$4"
82 O_FILES="$5"
83 A_FILES="$6"
84 LDLIBS="$7"
85
86 # The -Wl,--sort-section option is not supported by older versions of ld
87 SORT_SECTION=`check_cc "-Wl,--sort-section -Wl,alignment" ""`
88
89 # Static linking against glibc produces buggy executables
90 # (glibc does not cope well with ld --gc-sections).
91 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
92 # Note that glibc is unsuitable for static linking anyway.
93 # We are removing -Wl,--gc-sections from link command line.
94 GC_SECTION=`(
95 . ./.config
96 if test x"$CONFIG_STATIC" = x"y"; then
97     check_libc_is_glibc "" "-Wl,--gc-sections"
98 else
99     echo "-Wl,--gc-sections"
100 fi
101 )`
102
103 # Sanitize lib list (dups, extra spaces etc)
104 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
105
106 # First link with all libs. If it fails, bail out
107 echo "Trying libraries: $LDLIBS"
108 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
109 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
110 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
111 try $CC $CFLAGS $LDFLAGS \
112         -o $EXE \
113         -Wl,--sort-common \
114         $SORT_SECTION \
115         $GC_SECTION \
116         -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
117         $l_list \
118 || {
119     echo "Failed: $l_list"
120     cat $EXE.out
121     exit 1
122 }
123
124 # Now try to remove each lib and build without it.
125 # Stop when no lib can be removed.
126 while test "$LDLIBS"; do
127     $debug && echo "Trying libraries: $LDLIBS"
128     all_needed=true
129     for one in $LDLIBS; do
130         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
131         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
132         l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
133         test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
134         $debug && echo "Trying -l options: '$l_list'"
135         try $CC $CFLAGS $LDFLAGS \
136                 -o $EXE \
137                 -Wl,--sort-common \
138                 $SORT_SECTION \
139                 $GC_SECTION \
140                 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
141                 $l_list
142         if test $? = 0; then
143             echo " Library $one is not needed"
144             LDLIBS="$without_one"
145             all_needed=false
146         else
147             echo " Library $one is needed"
148         fi
149     done
150     # All libs were needed, can't remove any
151     $all_needed && break
152     # If there is no space char, the list has just one lib.
153     # I'm not sure that in this case lib really is 100% needed.
154     # Let's try linking without it anyway... thus commented out.
155     #{ echo "$LDLIBS" | grep -q ' '; } || break
156 done
157
158 # Make the binary with final, minimal list of libs
159 echo "Final link with: ${LDLIBS:-<none>}"
160 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
161 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
162 # --verbose gives us gobs of info to stdout (e.g. linker script used)
163 if ! test -f busybox_ldscript; then
164     try $CC $CFLAGS $LDFLAGS \
165             -o $EXE \
166             -Wl,--sort-common \
167             $SORT_SECTION \
168             $GC_SECTION \
169             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
170             $l_list \
171             -Wl,--warn-common \
172             -Wl,-Map -Wl,$EXE.map \
173             -Wl,--verbose \
174     || {
175         cat $EXE.out
176         exit 1
177     }
178 else
179     echo "Custom linker script 'busybox_ldscript' found, using it"
180     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
181     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
182     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
183     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
184     # This will eliminate most of the padding (~3kb).
185     # Hmm, "ld --sort-section alignment" should do it too.
186     try $CC $CFLAGS $LDFLAGS \
187             -o $EXE \
188             -Wl,--sort-common \
189             $SORT_SECTION \
190             $GC_SECTION \
191             -Wl,-T -Wl,busybox_ldscript \
192             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
193             $l_list \
194             -Wl,--warn-common \
195             -Wl,-Map -Wl,$EXE.map \
196             -Wl,--verbose \
197     || {
198         cat $EXE.out
199         exit 1
200     }
201 fi
202
203 . ./.config
204
205 sharedlib_dir="0_lib"
206
207 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
208     mkdir "$sharedlib_dir" 2>/dev/null
209     test -d "$sharedlib_dir" || {
210         echo "Cannot make directory $sharedlib_dir"
211         exit 1
212     }
213     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
214
215     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
216     try $CC $CFLAGS $LDFLAGS \
217             -o $EXE \
218             -shared -fPIC \
219             -Wl,--enable-new-dtags \
220             -Wl,-z,combreloc \
221             -Wl,-soname="libbusybox.so.$BB_VER" \
222             -Wl,--undefined=lbb_main \
223             -Wl,--sort-common \
224             $SORT_SECTION \
225             -Wl,--start-group $A_FILES -Wl,--end-group \
226             $l_list \
227             -Wl,--warn-common \
228             -Wl,-Map -Wl,$EXE.map \
229             -Wl,--verbose \
230     || {
231         echo "Linking $EXE failed"
232         cat $EXE.out
233         exit 1
234     }
235     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
236     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
237     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
238 fi
239
240 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
241     EXE="$sharedlib_dir/busybox_unstripped"
242     try $CC $CFLAGS $LDFLAGS \
243             -o $EXE \
244             -Wl,--sort-common \
245             $SORT_SECTION \
246             $GC_SECTION \
247             -Wl,--start-group $O_FILES -Wl,--end-group \
248             -L"$sharedlib_dir" -lbusybox \
249             -Wl,--warn-common \
250             -Wl,-Map -Wl,$EXE.map \
251             -Wl,--verbose \
252     || {
253         echo "Linking $EXE failed"
254         cat $EXE.out
255         exit 1
256     }
257     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
258     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
259 fi
260
261 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
262     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
263     gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
264     | grep -v "^#" \
265     | grep -v "^$" \
266     > applet_lst.tmp
267     while read name main junk; do
268
269         echo "\
270 void lbb_prepare(const char *applet, char **argv);
271 int $main(int argc, char **argv);
272
273 int main(int argc, char **argv)
274 {
275         lbb_prepare(\"$name\", argv);
276         return $main(argc, argv);
277 }
278 " >"$sharedlib_dir/applet.c"
279
280         EXE="$sharedlib_dir/$name"
281         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
282                 -o $EXE \
283                 -Wl,--sort-common \
284                 $SORT_SECTION \
285                 $GC_SECTION \
286                 -L"$sharedlib_dir" -lbusybox \
287                 -Wl,--warn-common \
288         || {
289             echo "Linking $EXE failed"
290             cat $EXE.out
291             exit 1
292         }
293         rm -- "$sharedlib_dir/applet.c" $EXE.out
294         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
295
296     done <applet_lst.tmp
297 fi
298
299 # libbusybox.so is needed only for -lbusybox at link time,
300 # it is not needed at runtime. Deleting to reduce confusion.
301 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
302 exit 0 # or else we may confuse make